/* dfopen.cc  implementation of the function "dataFileOpen"
*/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "dfopen.h"


FILE* dataFileOpen(char* fname)
{
	FILE *ofp, *wfp;
	// ofp : ꥸʥե(ե̾ : fname)
	// wfp : ѥե / ؿ dataFileOpen  wfp ֤

	// ե륪ץ
	if ((ofp = fopen(fname, "r")) == NULL) {
		fprintf(stderr, "Cannot open [%s].\n", fname);
		exit(1);
	}
	if ((wfp = tmpfile()) == NULL) {
		fprintf(stderr, "Cannot open [tmpfile].\n");
		exit(1);
	}

	// Ȥ򳰤ƽ񤭰ܤ
	int c; int col = 0;
	while ((c = fgetc(ofp)) != EOF) {
		col++;
		if (c == '\n') {
			fputc(c, wfp);
			col = 0;
		}
		else if (c == '#') {
			while (((c = fgetc(ofp)) != '\n') && (c != EOF)) ;
			if (c == EOF) break;
			else {
				if (col == 1) { // Ƭ '#'
					col = 0;
				}
				else {			//  '#'
					fputc(c, wfp);
					col = 0;
				}
			}
		}
		else if (c == '\"') {
			fputc(c, wfp);
			while (((c = fgetc(ofp)) != '\"') && (c != EOF)) {
				col++;
				fputc(c, wfp);
			}
			assert(c != EOF);	// '\"' ĤƤʤ
			col++;
			fputc(c, wfp);
		}
		else if (c == '\'') {
			fputc(c, wfp);
			while (((c = fgetc(ofp)) != '\'') && (c != EOF)) {
				col++;
				fputc(c, wfp);
			}
			assert(c != EOF);	// '\'' ĤƤʤ
			col++;
			fputc(c, wfp);
		}
		else {
			fputc(c, wfp);
		}
	}

	// wfp 򴬤᤹
	fseek(wfp, 0, 0);

	// ofp Ĥ wfp ֤
	fclose(ofp);
	return wfp;
}
