/* f_look.cc {\documentstyle{jsrc2latex}\rhead{\sl f\_look.cc\quad\thepage}
   \font\tenrm=cmtt10}f_look.h μ
{\ \begin{verbatim}
$Revision: 1.1 $ $Date: 2000/12/02 10:05:36 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <stdio.h>
#include <stdlib.h>

#include "common.h"		// ץˤ붦
#include "list.h"		// 饹 List 

#include "f_look.h"		// ʲǼؿ


void Pass_whites_and_comments(FILE*& fp, char& current, char comment)
{	//		Pass_whites_and_comments(FILE*&,char&,char) (define)

	if ((comment == ' ') || (comment == '\t')
		|| (comment == '\n') || (comment == EOF))
		{ Eprint(__FILE__, __LINE__); return; }
			// Pass_whites_and_comments(FILE*&,char&,char)
			// Invalid comment mark. (' ', '\t', '\n', EOF)

LOOP:
	// ۥ磻ȥڡ, Ԥ.
	while ((current == '\t') || (current == ' ') || (current == '\n'))
		current = fgetc(fp);

	// ʸ. ޤ.
	if ((comment != '\0') && (current == comment)) {
		do {
			current = fgetc(fp);
		} while ((current != '\n') && (current != EOF));
		goto LOOP;
	}
}


int Get_line_number(FILE*& fp)
{	//		Get_line_number(FILE*&) (define)

	if (fp == NULL) return 0;

	long belay = ftell(fp);		// fp θ֤߰򵭲.
	fseek(fp, 0L, 0);			// fp եƬذư.
	int line = 1;				// ֹǼ.
	do { if (fgetc(fp) == '\n') line++; } while (ftell(fp) < belay);
	fseek(fp, belay, 0);	// fp 򸵤᤹.

	return line;
}


Boolean Make_data_string(char* f_name, FILE*& fp, char& current,
						 char*& d_str, int& d_strlen,
						 char head, char tail, char comment, char control)
{	//		Make_data_string(char*,FILE*&,char&,char*&,int&,
	//						 char,char,char,char) (define)

	// δؿǤ, ʲΣĤΥѤ.
	// 		DATA_TOP, DATA_ON, DATA_OFF, DATA_END, FMT_ERR

	if ((head == tail) || (head == comment) || (head == control)
		|| (tail == comment) || (tail == control) || (comment == control))
		{ Eprint(__FILE__, __LINE__); return NO; }
			// Make_data_string(char*,FILE*&,char&,char*&,int&,
			//					char,char,char,char)
			// Cannot read data file.
			// The same charactor has selected for
			//     "head", "tail", "comment", "control".

	int depth = 0;				// ǡҰ֤ο.
	long belay = ftell(fp);		// fp ΰ֤򵭲.
	int k;						// .

DATA_TOP:	// 롼 "DATA_TOP" .
			// belay ǡʸľ head ꤹ.
	Pass_whites_and_comments(fp, current, comment);

	if (current == head) {
		depth++; belay = ftell(fp);		// depth, belay ι.
		// depth == 2 ʤ current ϥǡʸ.
		if (depth < 2)	// depth  1 ʤ.
			{ current = fgetc(fp); goto DATA_TOP; }
		if (depth > 2) {	// depth  2 ʾ. бԲ.
FMT_ERR:	// եޥåȥ顼ν.
			d_str = NULL; d_strlen = 0;
			k = Get_line_number(fp);
			fprintf(stderr, "\tAt %s : %d\n", f_name, k);
			return NO;
		}
	}
	else if ((depth == 0) || (current == EOF))	// եޥåȥ顼.
		goto FMT_ERR;
//	롼 "DATA_TOP" ޤ.

	// ǡʸϿ.
	fseek(fp, belay, 0);	//  fp ϥǡʸľ head .
	List char_list(Clf_c);		// ǡʸϿ.
	char* buffer;				// ҡפ˺륳ԡؤΥݥ.

DATA_ON:	// 롼 "DATA_ON". ǡʸʸ char_list ˼Ͽ.
	if ((buffer = new char) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "char", YES); exit(5); }
			// Make_data_string(char*,FILE*&,char&,char*&,int&,
			//					char,char,char,char)
			// For stocking charactor of data file.
	*buffer = current = fgetc(fp);

	if ((*buffer == tail) || (*buffer == head)) {
		if (*((char*) char_list.Tail()) == control) {
			// control + head, control + tail  head, tail ȸʤ.
			delete ((char*) char_list.Get_tail());
			char_list.Put_tail((void*) buffer);
			goto DATA_ON;
		}
		if (*buffer == head)	// եޥåȥ顼.
			{ delete buffer; goto FMT_ERR; }
		// ǡʸ. ǡʸ󳰤.
		*buffer = '\0';
		char_list.Put_tail((void*) buffer);
		if ((--depth) > 0) goto DATA_OFF;
		goto DATA_END;
	}
	switch (*buffer) {
		case '\n':
			if (*((char*) char_list.Tail()) == control)
				// control +  '\n' λ, Ϣ³.
				{ delete ((char*) char_list.Get_tail()); delete buffer; }
			else { char_list.Put_tail((void*) buffer); }
			goto DATA_ON;
		case EOF:	// եޥåȥ顼.
			delete buffer;
			goto FMT_ERR;
		default:	// *buffer == comment ξޤ.
			char_list.Put_tail((void*) buffer);
			goto DATA_ON;
	}
//	롼 "DATA_ON" ޤ.

DATA_OFF:	// 롼 "DATA_OFF".
			// ǡʸ󳰤ʸ.
	current = fgetc(fp);
	Pass_whites_and_comments(fp, current, comment);
		// ǡʸ󳰤ǤΥȤǧ.

	if (current == head)	// ǡʸ.
		{ depth++; goto DATA_ON; }
	if (current == tail) {	// ǡʸνλ.
		if ((buffer = new char) == NULL)
			{ Eprint_memory(__FILE__, __LINE__, "char", YES); exit(5); }
				// Make_data_string(char*,FILE*&,char&,char*&,int&,
				//					char,char,char,char)
				// For stocking charactor of data file.
		*buffer = '\0';
		char_list.Put_tail((void*) buffer);
		depth--;
		goto DATA_END;
	}
	if ((current == control) && (fgetc(fp) == '\n')) goto DATA_OFF;
		// control + '\n' λ, Ϣ³.
	goto FMT_ERR;
//	롼 "DATA_OFF" ޤ.

DATA_END:	// ǡʸ char_list ˼Ͽ줿. d_str .
	void** v_array;
	char_list.List_to_array(v_array, d_strlen);

	if ((d_str = new char[d_strlen]) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "char", d_strlen); exit(5); }
			// Make_data_string(char*,FILE*&,char&,char*&,int&,
			//					char,char,char,char)
			// For 'data_string'.
	for (k = 0; k < d_strlen; k++)	// ǡʸ񤭹.
		d_str[k] = *((char*) v_array[k]);

	return YES;
}


Boolean Get_string(FILE*& fp, char& current, char*& str, char control)
{	//		Get_string(FILE*&,char&,char*&,char) (define)

	Pass_whites_and_comments(fp, current, '\0');
	if (current == EOF) { str = NULL; return NO; }

	List char_list(Clf_c);	// ʸϿ.
	char* buffer;			// ҡפ˳ݤΰؤΥݥ.

LOOP:	// 롼 "LOOP". ʸϿ.
	if ((buffer = new char(current)) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "char", YES); exit(5); }
			// Get_string(FILE*&,char&,char*&,char)
			// For stocking charactor of string.
	*buffer = current;

	switch (*buffer) {
		case '\n':
			if ((char_list.Tail() != '\0') && (control != '\0')
				&& (*((char*) char_list.Tail()) == control)) {
				// control + '\n' λ, Ϣ³.
				delete buffer; delete ((char*) char_list.Get_tail());
				current = fgetc(fp);
				goto LOOP;
			}
			//  '\n' ϶ڤʸ.  case ʸ.
		case ' ':
		case '\t':
		case EOF:
			*buffer = '\0';
			char_list.Put_tail((void*) buffer);
			break;
		default:
			char_list.Put_tail((void*) buffer);
			current = fgetc(fp);
			goto LOOP;
	}
//	롼 "LOOP" ޤ.

	void** v_array; int array_len;
	char_list.List_to_array(v_array, array_len);

	if ((str = new char[array_len]) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "char", array_len); exit(5); }
			// Get_string(FILE*&,char&,char*&,char)
			// For 'string'.
	for (int k = 0; k < array_len; k++)		// ʸ񤭹.
		str[k] = *((char*) v_array[k]);

	return YES;
}


int Get_strings(FILE*& fp, char& current,
				char**& str_array, int num_of_strs,
				char comment, char control)
{	//		Get_strings(FILE*&,char&,char**&,int,char,char) (define)

	if ((str_array = new char*[num_of_strs]) == NULL) {
		Eprint_memory(__FILE__, __LINE__, "char*", num_of_strs); exit(5);
			// Get_strings(FILE*&,char&,char**&,int,char,char)
			// For array of strings.
	}

	int k, n;
	for (k = 0, n = num_of_strs; k < num_of_strs; k++) {
		Pass_whites_and_comments(fp, current, comment);
		if (Get_string(fp, current, str_array[k], control) != YES) {
			for (n = k; k < num_of_strs; k++) str_array[k] = NULL;
			break;
		}
	}

	return n;
}

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $
Revision: 1.1 ѹ
\'\0\'  NULL Ƚ񤤤Ƥäʬ\'\0\' Ƚ񤭤ޤ

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
