/* elm_t.h {\documentstyle{jsrc2latex}\rhead{\sl elm\_t.h\quad\thepage}
   \font\tenrm=cmtt10}ƥǥǥκ
{\ \begin{verbatim}
$Revision: 1.6 $ $Date: 1996/01/02 04:16:20 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#if !defined(elm_t_h)
#define elm_t_h

#include <stdio.h>
#include <time.h>
#include <fstream.h> // for ofstream

#include "element.h" // 饹 Element .
#include "p_tmp.h"	 // ƥץ졼ȥ饹 Receive, Send .

#include "khmkdir.h" // for kmkdir

//	饹 Element_for_test 

class Element_for_test : public Element {
	/*
		Element_for_test	ƥǥǥ
	*/

//	1.	ü, üҤκ.

	// ü.
protected:
	Receive<double> rp;
	void Register_receive_ports(void)
		{
		Register((void*) &rp);
		}

	// ü.
protected:
	Send<double> sp;
	void Register_send_ports(void)
		{
		Register((void*) &sp);
		}

//	2.	ѥ᡼, .

	// ѥ᡼.
protected:
	double p0;
	double p1;
	int mflag;	  // monitor flag
	ofstream monitor;

	// .
protected:
	double s0;
	double s1;
	time_t t0;

	// ѥ᡼, ̤ν.
protected:
  void Set_parameter(FILE* fp)
  {
	fscanf(fp, "%lf %lf", &p0, &p1);
	printf("\tPMT\t: elm_t\t: p0 = %f, p1 = %f\n\n", p0, p1);
	fscanf(fp, "%d", &mflag);
	if (mflag == 1) {
	  char mfilename[128];
	  mfilename[0] = '\0';
	  char absname[128];
	  Object::Absname(absname);
	  strcat(mfilename, "monitor");
	  strcat(mfilename, absname);
	  khmkdir(mfilename, 493); // 493 = 0755
	  strcat(mfilename, "/monitor.dat");
	  monitor.open(mfilename, ios::out);
	  monitor << "# monitor of " << absname << endl;
	}
  }

	// ̤ν.
protected:
	void Set_initial_state(FILE* fp)
		{
		fscanf(fp, "%ld %lf %ld %lf", &t0, &s0,
			   &current_time, &s1);
		printf("\tIST\t: elm_t\t: t0 = %ld, s0 = %f, "
				"current_time = %ld, s1 = %f\n\n",
				t0, s0, current_time, s1);
		}

	// ̤¸
  public:
	void Save_terminal_state(FILE* fp);

//	3.	ؿ, 󥹥ȥ饯, ǥȥ饯.
public:
  //////////////////////////////////////////////////////////////////////
  // Returns a pointer to a new Element
  virtual Element_for_test* NewElement() {
    return new Element_for_test(); }

  //////////////////////////////////////////////////////////////////////
  Boolean Init(char* o_name, int o_num, char* p_str = NULL)
  { return Element::Init(o_name, o_num, 0, p_str); }

  //////////////////////////////////////////////////////////////////////
  Element_for_test(char* o_name, int o_num, char* p_str = NULL)
		:	Element(),
			rp("rp", 0), sp("sp", 0),
			p0(0), p1(0), s0(0), s1(0)
  {
    class_name = "Element_for_test";
    rp.Set_owner(this); sp.Set_owner(this);
    Init(o_name, o_num, p_str); }
  //////////////////////////////////////////////////////////////////////
  Element_for_test(void)
		:	Element(),
			rp("rp", 0), sp("sp", 0),
			p0(0), p1(0), s0(0), s1(0)
  {
    class_name = "Element_for_test";
    rp.Set_owner(this); sp.Set_owner(this);
  }
  //////////////////////////////////////////////////////////////////////
  ~Element_for_test(void) {
	if (mflag == 1) {
	  monitor.close();
	}
  }

//	4.	黻ǽ.
	Boolean Initial_output(void)
	{
		double data = p0 * s0;
		sp.Send_data(current_time, data);
		printf("\tIOP\t: elm_t\t: At %ld : p0 * s0 = %f\n",
			current_time, p0 * s0);
		return YES;
	}

	time_t Calculate_time_step(void) { return 10; }
	Boolean Can_you_calculate(void) { return Can_you_calculate0(); }
	Boolean Calculate(void);
	Boolean Work(void) { return Work0(); }

};


#endif	//	! elm_t_h

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.6 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
