/* f_look.h {\documentstyle{jsrc2latex}\rhead{\sl f\_look.h\quad\thepage}
   \font\tenrm=cmtt10}եѴؿ
{\ \begin{verbatim}
$Revision: 1.1 $ $Date: 2000/03/17 05:59:31 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

եɤߤȤ뤿δؿƤޤ
}% end of latex-mode }

*/

#if !defined(f_look_h)
#define f_look_h

#include <stdio.h>

  ////////////////////////////////////////////////////////////////
  // Move forward the file pointer "fp" untill a non-white
  // character is encountered.  Comment strings are also skipped.
  //
  // ۥ磻ȥڡ, , ʸ, fp ʤޤ.
  // comment ϡʸ󳫻ϤʸǤ̾ϡ'#' 
  // Ƥcomment  NULL ΤȤϡʸ򥹥
  // פޤ
  //
  // <dl><dt>Example<dd>
  //	current = fgetc(fp);
  //    Pass_whites_and_comments(fp, current, '#');
  // </dl>
void Pass_whites_and_comments(
  FILE*& fp,        // file pointer
  char& current,    // input. the character to which the current
                    // "fp" points
                    // output. encountered non-white character
  char comment      // comment character
  );
	/*
	  	Pass_whites_and_comments(FILE*,char&,char)
			ۥ磻ȥڡ, ʸ

	ۥ磻ȥڡ, , ʸ, fp ʤޤ.

	ڡ, , Ԥμ comment_mark 줿, ʸȸ
	ʤ comment_mark ʹ, Ԥޤ fp ʤޤ.

	ARGUMENT:
		fp		¹Ԥե֤ؤΥݥ󥿤Ǽ뻲
					.
		current	fp ؤƤʸǼ뻲Ȱ.
		comment	ʸʸ.
					NULL ξ, ۥ磻ȥڡΤ.
	*/

  ////////////////////////////////////////////////////////////////
  // fp ؤե֤ιֹޤ.
int Get_line_number(
  FILE*& fp     // ֹĴ٤եΥݥ
  );
	/*
		Get_line_number(FILE*&)		ֹѴؿ

	fp ؤե֤ιֹޤ.

	ARGUMENT:
		fp	ֹĴ٤եΥݥ.
	RETURN:
		int	fp ؤե֤ιֹ. fp  NULL ξ 0
                ֤.
	*/


  ////////////////////////////////////////////////////////////////
  // ե f_name  fp ʹߤ, head, tail ˰Ϥޤ줿
  // ʬҡפ˳ݤʸ d_str ˥ԡ, ǡʸ
  // ޤ.
Boolean Make_data_string(
  char* f_name,     // ե̾
  FILE*& fp,        // եݥ
  char& current,    // fp ؤƤʸ
  char*& d_str,     // output. ǡʸ
  int& d_strlen,    // ǡʸĹ
  char head,        // '('
  char tail,        // ')'
  char comment,     // '#'
  char control      // Ϣ³ʸ '\'
  );
	/*
	  	Make_data_string(char*,FILE*&,char&,char*&,int&,
						 char,char,char,char)
			ǡʸκ

	ե f_name  fp ʹߤ, head_mark, tail_mark ˰Ϥޤ줿ʬ
	פ˳ݤʸ d_str ˥ԡ, ǡʸޤ.

	ǡʸ '\0', '\0' ³ƵҤޤ.
	head_mark, tail_mark 줾 '(', ')', λ,

	ҡפ
	ۥ磻ȥڡǶڤ줿ʸҡפ˥ԡ.

	㤨, head, tail, comment, control 줾 '(', ')', '#', '\' 
	,

		(aaa bbb)					==> |aaa bbb| + |\0\0|

		((aaa) (bbb))				==> [aaa\0bbb\0\0]

		# ʸ...
		((aaa)	# ʸ...
		 (bbb))						==> [aaa]+'\0'+[bbb]+'\0'+'\0'

		(aaa \
		bbb)						==> [aaa \tbbb]+[\0]+[\0]

		(aaa \( \) \\ \# bbb)		==> [aaa ( ) \ # bbb]+[\0]+[\0]

	ARGUMENT:
		f_name	fp Υե̾.
		fp		ǡʸФե֤ؤΥݥ󥿤Ǽ
					뻲Ȱ.
		current	fp ؤƤʸǼ뻲Ȱ.
		head		ǡʸ󳫻Ϥʸ.
		tail		ǡʸλʸ.
		comment	ʸʸ. NULL ξ, Ƚʤ.
		control	Ϣ³, head, tail, comment, control ʸ
					ʸ.
					NULL ξ, Ϣ³, ʸԤʤʤ.
	RETURN:
		char*		ҡפ˺ǡʸؤΥݥ.
		NULL		ǡե뤬եޥåȥ顼ξ.
					head_mark  tail_mark Ʊξ.
	EXIT:
		5			ǡʸѤεΰҡפ˳ݤǤʤ.
					(new)
	*/


  ////////////////////////////////////////////////////////////////
Boolean Get_string(FILE*& fp, char& current, char*& str, char control);
	/*
		Get_string(FILE*&,char&,char*&,char)

	ARGUMENT:
		fp
		current
		str
		control
	RETURN:
		YES
		NO
	*/


  ////////////////////////////////////////////////////////////////
int Get_strings(FILE*& fp, char& current,
				char**& str_array, int num_of_strs,
				char comment, char control);
	/*
		Get_strings(FILE*&,char&,char**&int,char,char)

	ARGUMENT:
		fp			ʸФե֤ؤΥݥ󥿤Ǽ
						뻲Ȱ.
		current		fp ؤƤʸǼ뻲Ȱ.
		array			ФʸΥݥ󥿤Ǽ뻲Ȱ.
						ʸФǤʤ NULL ꤹ.
						и array Ѥ, ͤȶѤ.
						how_many ȶѤ, ζ줬.
		how_many		Фʸꤹ.
		comment_mark	ʸʸ.
						NULL ξ, ʸʤ.
		control_mark	Ϣ³ʸ.
						NULL ξ, Ϣ³Ԥʤʤ.
	RETURN:
		int			ФǤʸο.
	*/


#endif	// ! f_look_h

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
