/*;  khmkdir.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl khmkdir.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:52:40 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/khmkdir.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#)

#ifndef khdir_h
#define khdir_h

#include <sys/stat.h>
#include <sys/types.h>

#ifdef _MSC_VER // for Visual C++
  #include <string.h> // to use 'strlen' and 'strcpy'
  #include <direct.h> // to use '_mkdir'
  #include <malloc.h> // to use 'malloc'
#else
  #include <iostream>
  #include <string>
#endif

#ifdef _MSC_VER // for Visual C++
typedef int mode_t;
#endif

////////////////////////////////////////////////////////////////////////
int khmkdir(	  //; make a directory
  char* dir,	  //; the directory to be made. Ex. foo/bar
  mode_t mode	  //; mode
  //
  // If the parent directory has not yet created, it will be also
  // created.  For example, dir is foo/bar and directory foo
  // does not exist, then foo is also created by this function.
);

#endif // khdir_h

/*; end of file */
